/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.xtext.example.methodname.methodName.Frequency;
import org.xtext.example.methodname.methodName.MethodNamePackage;
import org.xtext.example.methodname.methodName.Property;
import org.xtext.example.methodname.methodName.Rule;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.PropertyImpl#getFrequency <em>Frequency</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.PropertyImpl#getCriterion <em>Criterion</em>}</li>
 * </ul>
 *
 * @generated
 */
public class PropertyImpl extends MinimalEObjectImpl.Container implements Property
{
  /**
   * The default value of the '{@link #getFrequency() <em>Frequency</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFrequency()
   * @generated
   * @ordered
   */
  protected static final Frequency FREQUENCY_EDEFAULT = Frequency.ALWAYS;

  /**
   * The cached value of the '{@link #getFrequency() <em>Frequency</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFrequency()
   * @generated
   * @ordered
   */
  protected Frequency frequency = FREQUENCY_EDEFAULT;

  /**
   * The cached value of the '{@link #getCriterion() <em>Criterion</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCriterion()
   * @generated
   * @ordered
   */
  protected Rule criterion;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PropertyImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MethodNamePackage.Literals.PROPERTY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Frequency getFrequency()
  {
    return frequency;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setFrequency(Frequency newFrequency)
  {
    Frequency oldFrequency = frequency;
    frequency = newFrequency == null ? FREQUENCY_EDEFAULT : newFrequency;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.PROPERTY__FREQUENCY, oldFrequency, frequency));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Rule getCriterion()
  {
    if (criterion != null && criterion.eIsProxy())
    {
      InternalEObject oldCriterion = (InternalEObject)criterion;
      criterion = (Rule)eResolveProxy(oldCriterion);
      if (criterion != oldCriterion)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, MethodNamePackage.PROPERTY__CRITERION, oldCriterion, criterion));
      }
    }
    return criterion;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Rule basicGetCriterion()
  {
    return criterion;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setCriterion(Rule newCriterion)
  {
    Rule oldCriterion = criterion;
    criterion = newCriterion;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.PROPERTY__CRITERION, oldCriterion, criterion));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MethodNamePackage.PROPERTY__FREQUENCY:
        return getFrequency();
      case MethodNamePackage.PROPERTY__CRITERION:
        if (resolve) return getCriterion();
        return basicGetCriterion();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MethodNamePackage.PROPERTY__FREQUENCY:
        setFrequency((Frequency)newValue);
        return;
      case MethodNamePackage.PROPERTY__CRITERION:
        setCriterion((Rule)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.PROPERTY__FREQUENCY:
        setFrequency(FREQUENCY_EDEFAULT);
        return;
      case MethodNamePackage.PROPERTY__CRITERION:
        setCriterion((Rule)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.PROPERTY__FREQUENCY:
        return frequency != FREQUENCY_EDEFAULT;
      case MethodNamePackage.PROPERTY__CRITERION:
        return criterion != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (frequency: ");
    result.append(frequency);
    result.append(')');
    return result.toString();
  }

} //PropertyImpl
